spec:
  inputs:
    stage:
      default: deploy

    docker-registry:
      default: ""
    docker-user:
      default: $DOCKER_USER
    docker-token:
      default: $DOCKER_TOKEN

    platforms:
      default: "linux/amd64,linux/arm64"
    dockerfile:
      default: Dockerfile
    context:
      default: "."
---
############################
## GLOBAL VARIABLES
############################

variables:
  DOCKER_VERSION: "27.1.1"
  IMAGE_TAG: papierpain/$CI_PROJECT_NAME:$CI_COMMIT_TAG
  IMAGE_LATEST: papierpain/$CI_PROJECT_NAME:latest
  IMAGE_TEST: papierpain/$CI_PROJECT_NAME:unstable-$CI_COMMIT_REF_NAME

############################
## JOBS
############################

publish-image:
  stage: $[[ inputs.stage ]]
  image: ${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/docker:${DOCKER_VERSION}-alpine3.20
  services:
    - name: ${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/docker:${DOCKER_VERSION}-dind-alpine3.20
      alias: docker
  before_script:
    - echo "$[[ inputs.docker-token ]]" | docker login $[[ inputs.docker-registry ]] -u $[[ inputs.docker-user ]] --password-stdin
    - docker run --privileged --rm tonistiigi/binfmt --install all
    - docker buildx create --use --name multi-arch-builder --driver-opt network=host --driver-opt image=moby/buildkit:v0.14.1
  script:
    - |
      docker buildx build --platform $[[ inputs.platforms ]] -t ${IMAGE} \
        -f $[[ inputs.dockerfile ]] --push $[[ inputs.context ]]
  after_script:
    - docker logout
    - docker buildx rm multi-arch-builder
  rules:
    - if: $CI_COMMIT_TAG =~ /^[0-9]+\.[0-9]+\.[0-9]+$/
      variables:
        IMAGE: $IMAGE_TAG
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
      variables:
        IMAGE: $IMAGE_LATEST
    - if: $CI_COMMIT_REF_NAME && $CI_COMMIT_REF_NAME != $CI_DEFAULT_BRANCH
      variables:
        IMAGE: $IMAGE_TEST

create-release:
  stage: $[[ inputs.stage ]]
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  script: echo "💥 Creating release $CI_COMMIT_TAG"
  release:
    tag_name: $CI_COMMIT_TAG
    description: "💥 [RELEASE] Release $CI_COMMIT_TAG"
  rules:
    - if: $CI_COMMIT_TAG =~ /^[0-9]+\.[0-9]+\.[0-9]+$/

############################
## WORKFLOW
############################

workflow:
  name: ${PIPELINE_NAME}
  rules:
    - if: $CI_COMMIT_TAG =~ /^[0-9]+\.[0-9]+\.[0-9]+$/ && $CI_PIPELINE_SOURCE == "push"
      variables:
        IMAGE: $IMAGE_TAG
        PIPELINE_NAME: 💥 [RELEASE] Deploy ${IMAGE}
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
      variables:
        IMAGE: $IMAGE_LATEST
        PIPELINE_NAME: 🚀 [PROD] Deploy ${IMAGE}
    - if: $CI_PIPELINE_SOURCE == "web" && $CI_COMMIT_REF_NAME && $CI_COMMIT_REF_NAME != $CI_DEFAULT_BRANCH
      variables:
        IMAGE: $IMAGE_TEST
        PIPELINE_NAME: 🚚 [DEV] Deploy ${IMAGE}
    - when: never
